
module Plugins.Cover where

import TypeChecker.Monad.Errors

import Control.Monad

import Syntax.Internal
import Syntax.Values

import TypeChecker.Values
import TypeChecker.Values.DeBruijn
import TypeChecker.Monad.Context
import TypeChecker.Monad

import Plugins
import qualified Plugins.FOL as FOL
import Plugins.FOL.Options
import Plugins.FOL.Errors
import Plugins.FOL.Types
import Plugins.FOL.Arguments
import Plugins.FOL.Translation

import Plugins.Cover.Options

plugin :: SomePlugin
plugin = mkPlugin thePlugin

thePlugin =
    Plugin  { plName		= "cover"
	    , plHelp		= "The Cover plugin"
	    , plInit		= \_ -> return []
	    , plFinal		= FOL.finalFOL
	    , plCheck		= checkCover
	    , plInfer		= \_ _ _ _ -> failure noInferenceForFOLError
	    , plOptions		= coverOptions
	    , plDefaultOptions	= defaultOptions
	    }

checkCover = FOL.checkFOL' WithIncludes

