
data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data List (A:Set) : Set where
  nil  : List A
  (::) : A -> List A -> List A

data Maybe (A:Set) : Set where
  nothing : Maybe A
  just	  : A -> Maybe A

abstract
  Stack : Set -> Set
  Stack = List
  
  empty (A:Set) : Stack A
  empty = nil

  push (A:Set) : A -> Stack A -> Stack A
  push x s = x :: s

  pop (A:Set) : Stack A -> Maybe {A; Stack A}
  pop nil     = nothing
  pop (x::xs) = just (x,xs)

pushs (A:Set) : List A -> Stack A -> Stack A
pushs nil     s = s
pushs (x::xs) s = push x $ pushs xs s

fromList (A:Set) : List A -> Stack A
fromList xs = pushs xs empty

toList (A:Set) : Stack A -> List A
toList s with pop s =>
  s nothing	  = nil
  s (just (x,s')) = x :: toList s'

test : Stack Nat
test = fromList [1,2,3]

